package digiturno.Controlador;

import digiturno.Modelo.DigiturnoMDL;
import digiturno.Modelo.PacienteMDL;
import digiturno.Modelo.dgModelo;
import digiturno.Util.Utilidades;
import digiturno.Vista.Dialogo;
import digiturno.Vista.Ficho;
import digiturno.Vista.FichoB;
import digiturno.Vista.MarcoPrincipal;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.plaf.FontUIResource;

public class DigiturnoCTRL extends KeyAdapter implements ActionListener{

    private final MarcoPrincipal marco;
    private final DigiturnoMDL modelo;
    private dgModelo modelo2;
    private Ficho ficho;
    private FichoB fichoB;
    private final Utilidades utilidades;
    private String datosEscaner="";
    private String tipoDocumento, nroDocumento, Ap1, Ap2, Nom1, Nom2, Genero, FecNac;
    private PacienteMDL paciente;
    private String[] Lectura, Lectura2;
    private CardLayout clVistas, clUrgencias;
    private int sede, cola, prioridad, pabellon;
    public static boolean gestante, discapacidad, adultoMayor, ninoMenor, general, remitido;
    private String codigoSede;
    private final Color TEAL = new Color(0, 153, 153);
    private final Color LIGHT_RED = new Color(230, 90, 90);
    private JDialog preguntar;
    public static int EPS;
    private final int SURA = 99, SANITAS = 66, SALUD_TOTAL = 5, NUEVA_EPS = 316, OTRA_EPS = 1000;
    private static final long TIMER_DELAY = 4000;
    
    public DigiturnoCTRL(MarcoPrincipal marco, DigiturnoMDL modelo){
        this.utilidades = new Utilidades();
        DigiturnoCTRL.gestante = false;
        DigiturnoCTRL.discapacidad = false;
        DigiturnoCTRL.adultoMayor = false;
        DigiturnoCTRL.ninoMenor = false;
        DigiturnoCTRL.general = false;
        this.marco = marco;
        this.modelo = modelo;
        this.marco.setIconImage(utilidades.cargarIcono());
        this.marco.btnSalir.addActionListener(DigiturnoCTRL.this);
        this.marco.btnUrg.addActionListener(DigiturnoCTRL.this);
        this.marco.btnSiau.addActionListener(DigiturnoCTRL.this);
        this.marco.btnCext.addActionListener(DigiturnoCTRL.this);
        this.marco.btnTipoDocCC.addActionListener(DigiturnoCTRL.this);
        this.marco.btnTipoDocOtro.addActionListener(DigiturnoCTRL.this);
        this.marco.btnTipoDocTI.addActionListener(DigiturnoCTRL.this);
        this.marco.pnlSalirbtnCancel.addActionListener(DigiturnoCTRL.this);
        this.marco.pnlSalirbtnCheck.addActionListener(DigiturnoCTRL.this);
        this.marco.btnRegresar.addActionListener(DigiturnoCTRL.this);
        this.marco.btnSedeItagui.addActionListener(DigiturnoCTRL.this);
        this.marco.btnSedeBello.addActionListener(DigiturnoCTRL.this);
        this.marco.btnNormal.addActionListener(DigiturnoCTRL.this);
        this.marco.btnMujerG.addActionListener(DigiturnoCTRL.this);
        this.marco.btnNino.addActionListener(DigiturnoCTRL.this);
        this.marco.btnAdulto.addActionListener(DigiturnoCTRL.this);
        this.marco.btnDisca.addActionListener(DigiturnoCTRL.this);
        this.marco.btnCapDatosRegresar.addActionListener(DigiturnoCTRL.this);
        this.marco.btnInicio.addActionListener(DigiturnoCTRL.this);
        this.marco.btnPreguntaSi.addActionListener(DigiturnoCTRL.this);
        this.marco.btnPreguntaNo.addActionListener(DigiturnoCTRL.this);
        this.marco.btnCECita.addActionListener(DigiturnoCTRL.this);
        this.marco.btnCECitasEPS.addActionListener(DigiturnoCTRL.this);
        this.marco.btnCEAutST.addActionListener(DigiturnoCTRL.this);
        this.marco.btnCEAsCita.addActionListener(DigiturnoCTRL.this);
        this.marco.btnCEAutSura.addActionListener(DigiturnoCTRL.this);
        this.marco.btnCEProgCx.addActionListener(DigiturnoCTRL.this);
        this.marco.btnCEMnuPpal.addActionListener(DigiturnoCTRL.this);
        this.marco.btnSiauNormal.addActionListener(DigiturnoCTRL.this);
        this.marco.btnSiauMujer.addActionListener(DigiturnoCTRL.this);
        this.marco.btnSiauNino.addActionListener(DigiturnoCTRL.this);
        this.marco.btnSiauAdulto.addActionListener(DigiturnoCTRL.this);
        this.marco.btnSiauDisca.addActionListener(DigiturnoCTRL.this);
        this.marco.btnSiauMnuPpal.addActionListener(DigiturnoCTRL.this);
        this.marco.btnMsgAceptar.addActionListener(DigiturnoCTRL.this);
        this.marco.rdbSU.addActionListener(DigiturnoCTRL.this);
        this.marco.rdbNE.addActionListener(DigiturnoCTRL.this);
        this.marco.rdbOT.addActionListener(DigiturnoCTRL.this);
        this.marco.rdbSA.addActionListener(DigiturnoCTRL.this);
        this.marco.rdbST.addActionListener(DigiturnoCTRL.this);
    }
    
    public void Iniciar(){
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Windows".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
            UIManager.getLookAndFeelDefaults().put("OptionPane.sameSizeButtons", true);
            UIManager.put("OptionPane.buttonFont", new FontUIResource(new Font("Arial",Font.BOLD,100)));
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MarcoPrincipal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }        
        clVistas = (CardLayout) marco.pnlVistas.getLayout();
        clUrgencias = (CardLayout) marco.pnlUrg.getLayout();
        modelo2 = new dgModelo();
        escuchaTeclado();
        marco.btnMsgAceptar.setVisible(false);
        marco.lblCextGif.setVisible(false);
        marco.lblSiauGif.setVisible(false);
        marco.setResizable(true);
        marco.setExtendedState(JFrame.MAXIMIZED_BOTH);
        marco.setVisible(true);
    }
    
    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == marco.btnSedeItagui) {
            setSede(1);
            aInicio();            
        }else if (e.getSource() == marco.btnSedeBello) {
            setSede(2);
            aInicio();            
        }else if (e.getSource() == marco.btnUrg) {
            aUrgencias();
        }else if (e.getSource() == marco.btnCext) {
            aCext();
        }else if (e.getSource() == marco.btnSiau) {
            aSiau();
        }else if (e.getSource() == marco.btnTipoDocCC) {
            aPanelCapturaDatos("CC");
            deseleccionarEPS();
        }else if (e.getSource() == marco.btnTipoDocTI) {
            aPanelCapturaDatos("TI");
            deseleccionarEPS();
        }else if (e.getSource() == marco.btnTipoDocOtro) {
            clUrgencias.show(marco.pnlUrg, "panelOtroTipoDoc");
        }else if (e.getSource() == marco.btnSalir) {
            clVistas.show(marco.pnlVistas, "panelSalir");
        }else if(e.getSource() == marco.pnlSalirbtnCheck){
            utilidades.CerrarApp();
        }else if (e.getSource() == marco.pnlSalirbtnCancel) {
            clVistas.show(marco.pnlVistas, "panelInicio");
        }else if (e.getSource() == marco.btnMujerG) {
            RegistrarTurno("M", "", "", "", 1, cola, sede);
        }else if (e.getSource() == marco.btnNino) {
            RegistrarTurno("N", "", "", "", 2, cola, sede);
        }else if (e.getSource() == marco.btnAdulto) {
            RegistrarTurno("A", "", "", "", 3, cola, sede);
        }else if (e.getSource() == marco.btnDisca) {
            RegistrarTurno("D", "", "", "", 4, cola, sede);            
        }else if (e.getSource() == marco.btnNormal) {
            RegistrarTurno("E", "", "", "", 9, cola, sede);
        }else if (e.getSource() == marco.btnRegresar) {
            aPanelTipoDoc();
            deseleccionarEPS();
        }else if (e.getSource() == marco.btnCapDatosRegresar) {
            deseleccionarEPS();
            aPanelTipoDoc();
        }else if (e.getSource() == marco.btnInicio) {
            setSede(0);
            setCola(0);
            elegirSede();            
        }
        // BOTONES MODULO CONSULTA EXTERNA
        else if (e.getSource() == marco.btnCECita) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("F", "", "", "", 12, cola, sede);
        }else if (e.getSource() == marco.btnCEAsCita) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("F", "", "", "", 12, cola, sede);
        }else if (e.getSource() == marco.btnCECitasEPS) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("N", "", "", "", 13, cola, sede);
        }else if (e.getSource() == marco.btnCEAutST) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("T", "", "", "", 14, cola, sede);
        }else if (e.getSource() == marco.btnCEAutSura) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("U", "", "", "", 17, cola, sede);
        }else if (e.getSource() == marco.btnCEProgCx) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("P", "", "", "", 18, cola, sede);
        }
        else if(e.getSource() == marco.btnCEMnuPpal) {
            aInicio();
        }
        // BOTONES PANTALLA SIAU
        else if (e.getSource() == marco.btnSiauNormal) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("E", "", "", "", 39, cola, sede);
        }else if (e.getSource() == marco.btnSiauMujer) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("M", "", "", "", 30, cola, sede);
        }else if (e.getSource() == marco.btnSiauNino) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("N", "", "", "", 31, cola, sede);
        }else if (e.getSource() == marco.btnSiauAdulto) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("A", "", "", "", 32, cola, sede);
        }else if (e.getSource() == marco.btnSiauDisca) {
            mostrarGif();
            desactivarBotones();
            ocultarGif();
            RegistrarTurno("D", "", "", "", 33, cola, sede);
        }else if (e.getSource() == marco.btnSiauMnuPpal) {
            aInicio();
        }else if (e.getSource() == marco.btnMsgAceptar) {
            aPanelTDocs();
        }
        marco.pnlCapturaDatos.setFocusable(true);
        marco.pnlCapturaDatos.requestFocus();
    }
    
    private void escuchaTeclado(){
        marco.pnlCapturaDatos.addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                switch (e.getKeyCode()) {
                    case KeyEvent.VK_ENTER:
                        // System.out.println("datosEscaner: "+datosEscaner);
                        ProcesarLectura(datosEscaner);
                        datosEscaner = "";
                        break;
                    case KeyEvent.VK_ESCAPE:
                        aPanelTipoDoc();
                        break;
                }
            }
            @Override
            public void keyTyped(KeyEvent e) {
                String l = String.valueOf(e.getKeyChar()).toUpperCase();
                //System.out.println(" - Char: [ "+e.getKeyChar() + " ]" + " Conv: [ " + l + " ]");
                datosEscaner += l;
            }
        });
        marco.pnlUrg.addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                if(e.getKeyCode() == KeyEvent.VK_ESCAPE){
                    aInicio();
                }
            }
        });
        marco.pnlSiau.addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                if(e.getKeyCode() == KeyEvent.VK_ESCAPE){
                    aInicio();
                }
            }
        });
        marco.pnlCext.addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                if(e.getKeyCode() == KeyEvent.VK_ESCAPE){
                    aInicio();
                }
            }
        });
    }
    
    private void ProcesarLectura(String datosLeidos){
        LimpiarDatos();
        try {
            System.out.println("Lectura sin formato: "+datosLeidos);
            Lectura = datosLeidos.trim().split("/");        
            System.out.println("Lec0 - "+Lectura[0]);
            //System.out.println("Lec1 - "+Lectura[1]);
            Lectura2 = Lectura[1].split(",");
            Lectura = Lectura[0].split(",");
        } catch (Exception e) {
            System.out.println("datosLeidos: "+e.getMessage());
            aPanelMensaje(2);
            return;
        }
        switch(tipoDocumento){
            case "CC":                
                nroDocumento = Lectura[0];
                nroDocumento = nroDocumento.replaceAll("[^\\d]", "").replaceAll("^0{2}", "").replaceFirst("^0+(?!$)", "");
                Ap1 = Lectura[1].trim();
                Ap2 = Lectura[2].trim();
                Nom1 = Lectura[3].trim();
                Nom2 = Lectura[4].trim();
                Genero = Lectura[5].trim();
                FecNac = Lectura[6].trim();
                if (!tieneDigitos(Ap1)) {
                    paciente = new PacienteMDL(tipoDocumento, nroDocumento, Nom1, Nom2, Ap1, Ap2, Genero, FecNac, EPS);
                    // System.out.println("Paciente.toString CC :"+paciente.toString());
                    if (paciente.validarDatosPaciente()) {
                        // CODIGO PARA ESTABLECER LA PRIORIDAD DEL PACIENTE
                        aPregunta(tipoDocumento);
                        // FIN VALIDACION PRIORIDAD PACIENTE
                        if (paciente.crearIngreso(pabellon, codigoSede, prioridad)){
                            //JOptionPane.showMessageDialog(marco, "PACIENTE CREADO", "DIGITURNO", JOptionPane.INFORMATION_MESSAGE);
                            fichoB = new FichoB(utilidades.ObtenerFecha2(), "");
                            aPanelMensaje(1);
                            fichoB.dispose();
                            fichoB = null;
                        }else{
                            aPanelMensaje(0);
                        }
                        paciente = null;
                    }else{
                        aPanelMensaje(4);
                    }
                }else{
                    aPanelMensaje(2);
                }
                break;
//            case "TI":
//                nroDocumento = Lectura2[0];
//                nroDocumento = nroDocumento.replaceAll("[^\\d]", "").replaceAll("^0{2}", "").replaceFirst("^0+(?!$)", "");
//                Ap1 = Lectura2[1].trim();
//                Ap2 = Lectura2[2].trim();
//                Nom1 = Lectura2[3].trim();
//                Nom2 = Lectura2[4].trim();
//                Genero = Lectura2[5].trim();
//                FecNac = Lectura2[6].trim();
//                if (nroDocumento.length()==11) {
//                    try {
//                        double nroD = Double.parseDouble(nroDocumento);
//                        paciente = new PacienteMDL(tipoDocumento, nroDocumento, Nom1, Nom2, Ap1, Ap2, Genero, FecNac, EPS);
//                        //System.out.println("Paciente.toString TI :"+paciente.toString());
//                        if (paciente.validarDatosPaciente()) {
//                            // CODIGO PARA ESTABLECER LA PRIORIDAD DEL PACIENTE
//                            aPregunta(tipoDocumento);
//                            // FIN VALIDACION PRIORIDAD PACIENTE
////                            if (paciente.crearIngreso(pabellon, codigoSede, prioridad)) {
////                                //JOptionPane.showMessageDialog(marco, "PACIENTE CREADO", "DIGITURNO", JOptionPane.INFORMATION_MESSAGE);
////                                fichoB = new FichoB(utilidades.ObtenerFecha2(), "");
////                                aPanelMensaje(1);
////                                fichoB.dispose();
////                                fichoB = null;
////                            }else{
////                                aPanelMensaje(0);
////                            }
////                            paciente = null;
//                        }else{
//                            aPanelMensaje(0);
//                        }
//                    } catch (NumberFormatException e) {
//                        System.out.println("Error formateando numero de TI: "+e.getMessage());
//                        aPanelMensaje(2);
//                    }   
//                }
//                break;
//            default:
//                aPanelMensaje(2);
//                break;
        }   
    }
    
    private boolean tieneDigitos(String texto){
        if (texto != null && !texto.isEmpty()){
            for (char c : texto.toCharArray()){
                if (Character.isDigit(c))
                    return true;
            }
        }
        return false;
    }
    
    private void LimpiarDatos(){
        Ap1 = null;
        Ap2 = null;
        Nom1 = null;
        Nom2 = null;
        Genero = null;
        nroDocumento = null;
        FecNac = null;
        datosEscaner = "";
        Lectura = null;
        Lectura2 = null;
        paciente = null;
        ficho = null;
        fichoB = null;
        gestante = false;
        discapacidad = false;
        adultoMayor = false;
        ninoMenor = false;
        general = false;
        prioridad = 0;
        preguntar = null;
        remitido = false;
    }
    
    private void elegirSede(){
        clVistas.show(marco.pnlVistas, "panelSede");
        setSede(0);
        setTituloSede();
    }
    
    private void aInicio(){
        clVistas.show(marco.pnlVistas, "panelInicio");
        setTituloSede();
        if (cola<=0) {
            marco.lblCtvoTurno.setText("");
        }else{
           turnoActual(cola, sede); 
        }
        
//      Cambio se activa boton de consulta externa para ambas sedes        
//        if (sede==1) {
//            marco.btnCext.setEnabled(true);
//        }else{
//            marco.btnCext.setEnabled(false);
//        }
//        detenerTimer();
    }
    
    private void aUrgencias(){
        setCola(1);
        clVistas.show(marco.pnlVistas, "panelUrgencias");
        marco.pnlUrg.requestFocus();
        aPanelTDocs();
        turnoActual(cola, sede);
    }
    
    private void aCext(){
        setCola(2);
        clVistas.show(marco.pnlVistas, "panelCext");
        marco.pnlCext.requestFocus();
        turnoActual(cola, sede);
        if (sede==2) {
            marco.btnCEAutST.setEnabled(false);
            marco.btnCECitasEPS.setEnabled(false);
            marco.btnCEAutSura.setEnabled(false);
            marco.btnCEAsCita.setEnabled(false);
            marco.btnCEMnuPpal.setEnabled(false);
        }else{
            marco.btnCEAutST.setEnabled(true);
            marco.btnCECitasEPS.setEnabled(true);
            marco.btnCEAutSura.setEnabled(true);
            marco.btnCEAsCita.setEnabled(true);
            marco.btnCEMnuPpal.setEnabled(true);
        }
    }
    
    private void aSiau(){
        setCola(3);
        clVistas.show(marco.pnlVistas, "panelSiau");
        marco.pnlSiau.requestFocus();
        turnoActual(cola, sede);
    }
    
    private void aPanelTipoDoc(){
        clUrgencias.show(marco.pnlUrg, "panelTiposDoc");
        marco.pnlUrg.requestFocus();
        turnoActual(cola, sede);
    }
    
    private void aPanelTDocs(){
        clUrgencias.show(marco.pnlUrg, "panelTiposDoc");
        marco.pnlUrg.requestFocus();
        turnoActual(cola, sede);
//        detenerTimer();
        deseleccionarEPS();
    }
    
    private void aPanelCapturaDatos(String td){
        if (!setEPS()) {            
            parametrosPregunta(true, 3);
            return;
        }
        System.out.println("EPS Seleccionada:__ "+EPS);
        clUrgencias.show(marco.pnlUrg, "panelCapuraDatos");
        tipoDocumento = td;
    }
    
    private void aPanelMensaje(int m){
        String msg = "";
        int delay=5;
        switch(m){
            case 0:
                msg = "<html><center>ERROR,"
                        + " ACERQUE NUEVAMENTE EL DOCUMENTO AL LECTOR.</center></html>";
                marco.pnlMsgLblMsg.setForeground(LIGHT_RED);
                delay = 4;
                break;
            case 1:
                msg = "<html><center>TOME SU FICHO. <br>"
                        + "REGISTRO EXITOSO.</center></html>";
                marco.pnlMsgLblMsg.setForeground(TEAL);
                delay = 3;
                break;            
            case 2:
                msg = "<html><center>VERIFIQUE TIPO DE DOCUMENTO!.</center></html>";
                marco.pnlMsgLblMsg.setForeground(LIGHT_RED);
                break;
            case 3:
                msg = "<html><center>ERROR, <br> POR FAVOR INTENTE NUEVAMENTE.</center></html>";
                marco.pnlMsgLblMsg.setForeground(LIGHT_RED);
                break;
            case 4:
                msg = "<html><center>ERROR, <br> NÚMERO DE DOCUMENTO INVALIDO.</center></html>";
                marco.pnlMsgLblMsg.setForeground(LIGHT_RED);
                break;
        }
        marco.pnlMsgLblMsg.setText(msg);
        clUrgencias.show(marco.pnlUrg, "panelMensaje");
//        timeout = new Timer(delay, new  ActionListener() {
//            @Override
//            public void actionPerformed(ActionEvent e) {
//                if (sede==1) {
//                    aPanelTDocs();
//                }else{
//                    if (sede == 2 && cola == 3 || cola == 1) {
//                        aInicio();
//                    }
//                }                
//            }
//        });
//        timeout.start();
        final Runnable timeOut = new Runnable() {
            @Override
            public void run() {
                
            if (sede==1) {
                    aPanelTDocs();
                }else{
                    if (sede == 2 && cola == 3 || cola == 1) {
                        aInicio();
                    }
                }
            }
        };
        final ScheduledExecutorService delayedAction = Executors.newScheduledThreadPool(1);
        final ScheduledFuture<?> delayHandler = delayedAction.schedule(timeOut, delay, TimeUnit.SECONDS);
        
    }    
    
    private void aPregunta(String tipoDoc){
        switch(tipoDoc){
            case "CC":
                if (paciente.getGenero().equalsIgnoreCase("F")) {
                    parametrosPregunta(true, 1);
                    prioridad = (gestante) ? 1 : 9;
                }
                if (!gestante) {
                    adultoMayor = (paciente.edadPaciente(paciente.getFechaNacimiento())>65);
                    prioridad = (adultoMayor) ? 3 : 9;
                    if (!adultoMayor) {
                        parametrosPregunta(true, 2);
                        prioridad = (discapacidad) ? 4 : 9;
                        if (!discapacidad) {
                            parametrosPregunta(true, 4);
                            prioridad = (remitido) ? 5 : 9;
                        }
                    }
                }
                break;
            case "TI":
//                if (paciente.getGenero().equalsIgnoreCase("F")) {
//                    gestante = (utilidades.prioridad(1)==0);
//                    prioridad = (gestante) ? 1 : 9;
//                }
//                if (!gestante) {
//                    ninoMenor = (paciente.edadPaciente(paciente.getFechaNacimiento())<6);
//                    prioridad = (ninoMenor) ? 2 : 9;
//                    System.out.println("Edad Paciente: "+paciente.edadPaciente(paciente.getFechaNacimiento()));
//                    if (!ninoMenor) {
//                        discapacidad = (utilidades.prioridad(2)==0);
//                        prioridad = (discapacidad) ? 4 : 9;
//                        if (!discapacidad) {
//                            parametrosPregunta(true, 4);
//                            prioridad = (remitido) ? 5 : 9;
//                        }
//                    }
//                }
                break;
        }
    }
    
    private void parametrosPregunta(boolean modal, int opcion){
        preguntar = new Dialogo(null, modal, opcion);
        preguntar.setModal(modal);
        preguntar.setLocationRelativeTo(null);
        preguntar.setVisible(true);
    }
    
    private boolean setEPS(){
        if (marco.rdbSU.isSelected()) {
            EPS = SURA;
            return true;
        }
        if (marco.rdbSA.isSelected()) {
            EPS = SANITAS;
            return true;
        }
        if (marco.rdbST.isSelected()) {
            EPS = SALUD_TOTAL;
            return true;
        }
        if (marco.rdbNE.isSelected()) {
            EPS = NUEVA_EPS;
            return true;
        }
        if (marco.rdbOT.isSelected()) {
            EPS = OTRA_EPS;
            return true;
        }
        return false;
    }
    
    private void deseleccionarEPS(){        
        try {
            marco.btngEps.clearSelection();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }
    
    private void setSede(int s){
        sede = s;        
    }
    
    private void setCola(int c){
        cola = c;
    }
        
    private void setTituloSede(){
        String sedeSeleccionada;
        switch(sede){
            case 1:
                sedeSeleccionada = "ITAGUÍ";
                pabellon = 18;
                codigoSede = "001";
                break;
            case 2:
                sedeSeleccionada = "BELLO";
                pabellon = 30;
                codigoSede = "002";
                break;
            default:
                sedeSeleccionada = "";
                pabellon = 0;
                codigoSede = null;
                break;                    
        }
        marco.lblTitulo.setText("CLINICA ATIOQUIA S.A." + " " + sedeSeleccionada);
    }
    
    private void RegistrarTurno(String tipoTurno, String tipoDoc, String doc, String nombrec, int prioridad, int cola, int sede ){
        if (modelo2.RegistrarTurno(tipoTurno, tipoDoc, doc, nombrec, prioridad, cola, sede)) {
            modelo2.ConsultarTurno(cola, sede);
            ficho = new Ficho(modelo2.getFechaUltimoTurno(), modelo2.getUltimoTurno());
            ficho.dispose();
    //        aPanelTipoDoc();
            ficho = null;
            aPanelMensaje(1);
        }else{
            aPanelMensaje(3);
        }
    }
    
    private void turnoActual(int c, int s){
        modelo2.ConsultarTurno(c, s);
        marco.lblCtvoTurno.setText(modelo2.getUltimoTurno());
    }
    
    private void ocultarGif(){
        TimerTask tarea = new TimerTask() {
            @Override
            public void run() {
                activarBotones();
                switch (cola) {
                    case 2:
                        marco.lblCextGif.setVisible(false);
                        turnoActual(cola, sede);
                        break;
                    case 3:
                        marco.lblSiauGif.setVisible(false);
                        break;
                    default:
                        break;
                }
            }
        };
        Timer timer = new Timer("OcultarGif");
        timer.schedule(tarea, TIMER_DELAY);
    }
    
    private void mostrarGif(){
        switch (cola) {
            case 1:   
                marco.lblCextGif.setVisible(true);
                break;
            case 2:
                marco.lblCextGif.setVisible(true);
                break;
            case 3:
                marco.lblSiauGif.setVisible(true);
                break;
            default:
                break;
        }        
    }
    
    private void desactivarBotones(){
        switch (cola) {
            case 1:
//                marco.btnNormal.setVisible(false);
//                marco.btnNino.setVisible(false);
//                marco.btnMujerG.setVisible(false);
//                marco.btnAdulto.setVisible(false);
//                marco.btnDisca.setVisible(false);
                marco.btnNormal.setEnabled(false);
                marco.btnNino.setEnabled(false);
                marco.btnMujerG.setEnabled(false);
                marco.btnAdulto.setEnabled(false);
                marco.btnDisca.setEnabled(false);
                break;
            case 2:
//                marco.btnAutNuevaEps.setVisible(false);
//                marco.btnAutSaludTotal.setVisible(false);
//                marco.btnAutSanitas.setVisible(false);
//                marco.btnAutSura.setVisible(false);
//                marco.btnConsultaExt.setVisible(false);
//                marco.btnConSura.setVisible(false);
//                marco.btnProgCx.setVisible(false);
                marco.btnCECitasEPS.setEnabled(false);
                marco.btnCEAutST.setEnabled(false);
                marco.btnCEAutSura.setEnabled(false);
                marco.btnCECita.setEnabled(false);
                marco.btnCEAsCita.setEnabled(false);
                marco.btnCEProgCx.setEnabled(false);
                marco.btnCEMnuPpal.setEnabled(false);
                break;
            case 3:
//                marco.btnSiauNormal.setVisible(false);
//                marco.btnSiauMujer.setVisible(false);
//                marco.btnSiauAdulto.setVisible(false);       
//                marco.btnSiauNino.setVisible(false);
//                marco.btnSiauDisca.setVisible(false);
                marco.btnSiauNormal.setEnabled(false);
                marco.btnSiauMujer.setEnabled(false);
                marco.btnSiauAdulto.setEnabled(false);       
                marco.btnSiauNino.setEnabled(false);
                marco.btnSiauDisca.setEnabled(false);
                break;
            default:
                break;
        }
    }
    
    private void activarBotones(){
        switch (cola) {
            case 1:
//                marco.btnNormal.setVisible(true);
//                marco.btnNino.setVisible(true);
//                marco.btnMujerG.setVisible(true);
//                marco.btnAdulto.setVisible(true);
//                marco.btnDisca.setVisible(true);
                marco.btnNormal.setEnabled(true);
                marco.btnNino.setEnabled(true);
                marco.btnMujerG.setEnabled(true);
                marco.btnAdulto.setEnabled(true);
                marco.btnDisca.setEnabled(true);
                break;
            case 2:
//                marco.btnAutNuevaEps.setVisible(true);
//                marco.btnAutSaludTotal.setVisible(true);
//                marco.btnAutSanitas.setVisible(true);
//                marco.btnAutSura.setVisible(true);
//                marco.btnConsultaExt.setVisible(true);
//                marco.btnConSura.setVisible(true);
//                marco.btnProgCx.setVisible(true);
                if (sede==1) {
                    marco.btnCECitasEPS.setEnabled(true);
                    marco.btnCEAutST.setEnabled(true);
                    marco.btnCEAutSura.setEnabled(true);
                    marco.btnCECita.setEnabled(true);
                    marco.btnCEAsCita.setEnabled(true);
                    marco.btnCEProgCx.setEnabled(true);
                    marco.btnCEMnuPpal.setEnabled(true);
                }else if (sede==2) {
                    marco.btnCECita.setEnabled(true);
                    marco.btnCEProgCx.setEnabled(true);
                }                
                break;
            case 3:
//                marco.btnSiauNormal.setVisible(true);
//                marco.btnSiauMujer.setVisible(true);
//                marco.btnSiauAdulto.setVisible(true);         
//                marco.btnSiauNino.setVisible(true);
//                marco.btnSiauDisca.setVisible(true);
                marco.btnSiauNormal.setEnabled(true);
                marco.btnSiauMujer.setEnabled(true);
                marco.btnSiauAdulto.setEnabled(true);         
                marco.btnSiauNino.setEnabled(true);
                marco.btnSiauDisca.setEnabled(true);
                break;
            default:
                break;
        }
    }
}
