package digiturno.Modelo;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.GregorianCalendar;
//import javax.swing.JOptionPane;

public class PacienteMDL {
    
    dgModelo mdlDigiTurno;
    private String nroTurno;
    String[] ymd;
    private final String BDCLINICA = "dataBaseName";
    
    public PacienteMDL(String tipoDocumento, String nroDocumento, String primerNombre, String segundoNombre, 
            String primerApellido, String segundoApellido, String Genero, String fechaNacimiento, int eps) {
        this.tipoDocumento = tipoDocumento;
        this.nroDocumento = nroDocumento;
        this.primerNombre = primerNombre;
        this.segundoNombre = segundoNombre;
        this.primerApellido = primerApellido;
        this.segundoApellido = segundoApellido;
        this.Genero = Genero;
        // MODIFICACION DE LA FECHA PARA HACERLA CONCORDAR CON EL FORMATO DE HOSVITAL
        ymd = fechaNacimiento.split("-");
        this.fechaNacimiento = ymd[0]+"-"+ymd[2]+"-"+ymd[1];
        ymd = null;
        this.eps = eps;
    }

    public void registrarTurno(){
        mdlDigiTurno = new dgModelo();
    }
    
    public String getTipoDocumento() {
        return tipoDocumento;
    }

    public void setTipoDocumento(String tipoDocumento) {
        this.tipoDocumento = tipoDocumento;
    }

    public String getNroDocumento() {
        return nroDocumento;
    }

    public void setNroDocumento(String nroDocumento) {
        this.nroDocumento = nroDocumento;
    }

    public String getPrimerNombre() {
        return primerNombre;
    }

    public void setPrimerNombre(String primerNombre) {
        this.primerNombre = primerNombre;
    }

    public String getSegundoNombre() {
        return segundoNombre;
    }

    public void setSegundoNombre(String segundoNombre) {
        this.segundoNombre = segundoNombre;
    }

    public String getPrimerApellido() {
        return primerApellido;
    }

    public void setPrimerApellido(String primerApellido) {
        this.primerApellido = primerApellido;
    }

    public String getSegundoApellido() {
        return segundoApellido;
    }

    public void setSegundoApellido(String segundoApellido) {
        this.segundoApellido = segundoApellido;
    }

    public String getGenero() {
        return Genero;
    }

    public void setGenero(String Genero) {
        this.Genero = Genero;
    }

    public String getFechaNacimiento() {
        return fechaNacimiento;
    }

    public void setFechaNacimiento(String fechaNacimiento) {
        this.fechaNacimiento = fechaNacimiento;
    }
    
    public String getNroTurno(){
        return nroTurno;
    }
    
    public int getEps(){
        return eps;
    }
    
    public void setEps(int c){
        eps = c;
    }
    
    public boolean validarDatosPaciente(){
        try {
            if (nroDocumento == null || nroDocumento.length()<6 || nroDocumento.equalsIgnoreCase("")) {
                System.out.println("Nro documento invalido");
                return false;
            }
            if (tipoDocumento.equalsIgnoreCase("CC") && nroDocumento.length()>10) {
                System.out.println("Nro documento invalido");
                return false;
            }
            if (tipoDocumento.equalsIgnoreCase("TI") && nroDocumento.length()>11) {
                System.out.println("Nro documento invalido");
                return false;
            }
            if (primerNombre == null || primerNombre.length()<1) {
                System.out.println("Primer Nombre invalido");
                return false;
            }
            if (primerApellido == null || primerApellido.length()<1) {
                System.out.println("Primer Apellido invalido");
                return false;
            }
            if (Genero == null || Genero.length()<1 || Genero.equalsIgnoreCase("")) {
                System.out.println("Genero invalido");
                return false;
            }
            if (eps != 66 && eps != 5 && eps != 316 && eps != 99 && eps != 1000) {
                System.out.println("Eps Invalida__: "+eps);
                return false;
            }
        } catch (Exception e) {
            System.out.println("Error validar datos Paciente: "+e.getMessage());
            return false;
//            e.printStackTrace();
        }
        return true;
    }
    
    public int edadPaciente(String fecN){
        int edad, meses, dias;
        try {
            String[] aux = fecN.split("-");
            int y, m, d;
            y = Integer.parseInt(aux[0]);
            m = Integer.parseInt(aux[1])-1;
            d = Integer.parseInt(aux[2]);            
            
            // NUEVA VALIDACION 
            System.out.println("Longitud " + String.valueOf(y).length());
            if (String.valueOf(y).length()<4) {
                System.out.println("Error calculando la edad en el año");
                return 0;
            }
            
            Calendar fecNacimiento = new GregorianCalendar(y, m, d);
            Calendar fechaActual = Calendar.getInstance();

            // Cálculo de las diferencias.
            edad = fechaActual.get(Calendar.YEAR) - fecNacimiento.get(Calendar.YEAR);
            meses = fechaActual.get(Calendar.MONTH) - fecNacimiento.get(Calendar.MONTH);
            dias = fechaActual.get(Calendar.DAY_OF_MONTH) - fecNacimiento.get(Calendar.DAY_OF_MONTH);

            if(meses < 0 || (meses<=0 && dias < 0)) { 
                edad--;
            }
            return edad;
        } catch (NumberFormatException e) {
            System.out.println("Error calculando edad paciente: "+e.getMessage());
            return 0;
        }
    }
    
    public boolean crearIngreso(int Pabellon, String Sede, int prioridad){
        boolean res = false;
        try {
            Conexion conexion = new Conexion("Usuario", "Clave");
            Connection cn;
            CallableStatement procedimiento;
            cn = conexion.Conectar();
            procedimiento = cn.prepareCall("{call "+BDCLINICA+".dbo.SP_IngresoBasico(?,?,?,?,?,?,?,?,?,?,?,?,?,?)}");
            procedimiento.setString(1, nroDocumento);
            procedimiento.setString(2, tipoDocumento);
            procedimiento.setString(3, primerNombre);
            procedimiento.setString(4, segundoNombre);
            procedimiento.setString(5, primerApellido);
            procedimiento.setString(6, segundoApellido);
            procedimiento.setString(7, fechaNacimiento);
            procedimiento.setString(8, Genero);
            procedimiento.setInt(9, Pabellon);
            procedimiento.setString(10, Sede);
            procedimiento.registerOutParameter(11, java.sql.Types.INTEGER);
            procedimiento.registerOutParameter(12, java.sql.Types.VARCHAR);
            procedimiento.setInt(13, prioridad);
            procedimiento.setInt(14, eps);
            procedimiento.execute();
            if (procedimiento.getInt(11)==1) {
                res = true;
                nroTurno = procedimiento.getString(12);
            }
            System.out.println("error get int__:"+procedimiento.getInt(11));
            cn.close();
        } catch (SQLException e) {
//            e.printStackTrace();
            System.out.println("Error crear ingreso: "+e.getMessage());
//            e.printStackTrace();
//            res = false;
        }
        return res;
    }
    
    @Override
    public String toString(){
        return tipoDocumento+": "+nroDocumento+", "+primerNombre+" "+segundoNombre+" "+primerApellido+" "+
                segundoApellido+", "+Genero+", "+fechaNacimiento+", "+eps;
    }
    
    private String tipoDocumento, nroDocumento, primerNombre, segundoNombre, primerApellido,
            segundoApellido, Genero, fechaNacimiento;
    
    private int eps;
}
